/*
 * $Id: f_compositeNumEntry.js,v 1.2 2007/01/24 21:38:18 oeuillot Exp $
 */

/**
 * 
 * @class public f_compositeNumEntry extends f_component, fa_compositeNumEntry, fa_required, fa_message
 * @author Olivier Oeuillot (latest modification by $Author: oeuillot $)
 * @version $Revision: 1.2 $ $Date: 2007/01/24 21:38:18 $
 */

var __prototype={

	f_compositeNumEntry: function() {
		this.f_super(arguments);
		
		var validatorParams=f_core.GetAttribute(this, "v:clientValidatorParams");
		if (validatorParams) {
			this._validatorParams=f_core.ParseParameters(validatorParams);
		}
		
		if (f_class.IsClassDefined("f_messageContext")) {
			f_core.AddCheckListener(this, this);	
		}
	},
	/*
	f_finalize: function() {

		// this._validatorParams=undefined; // Map<String, String>
					
		this.f_super(arguments);
	},
	*/
	f_performCheckValue: function() {		
	},
	/**
	 * @method protected
	 * @return void
	 */
	f_updateStyleClass: function(postSuffix) {
		var suffix="";

		if (this.f_isDisabled()) {
			suffix+="_disabled";

		} else if (this.f_isReadOnly()) {
			suffix+="_readOnly";
		}
		
		if (postSuffix) {
			suffix+=postSuffix;
		}
	
		var claz=this.f_computeStyleClass(suffix);
		if (this.className!=claz) {
			this.className=claz;
		}
	},
	/**
	 * @method protected
	 * @return String
	 */
	f_computeStyleClass: function(suffix) {	
		var styleClass=this.f_super(arguments, suffix);

		if (this._hasFocus && !this.f_isDisabled()) {
			var focusStyleClass=this.f_getFocusStyleClass();

			if (focusStyleClass) {
				styleClass+=" "+focusStyleClass;
			}
		}
		
		var msg=this._currentMessage;
		if (msg) {
			var severity=msg.f_getSeverity();
			
			var severityClass=this.f_getStyleClassFromSeverity(severity);
			
			if (!severityClass && severity>=f_messageObject.SEVERITY_ERROR) {
				severityClass=this.f_getMainStyleClass()+"_error";
			}
			
			if (severityClass) {
				styleClass+=" "+severityClass;
			}
		}

		return styleClass;
	},
	f_performMessageChanges: function() {	
		var messages=f_messageContext.ListMessages(this);
		
		var msg;
		for(var j=0;j<messages.length;j++) {
			var m=messages[j];
			
			if (!msg || msg.f_getSeverity()<m.f_getSeverity()) {
				msg=m;
			}
		}
		
		f_core.Debug(f_compositeNumEntry, "Change message to '"+msg+"' for component "+this.id+".");
						
		if (msg==this._currentMessage) {
			return;
		}
		
		this._currentMessage=msg;
		
		this.f_updateStyleClass();
	},
	/**
	 * @method protected
	 * @return void
	 */
	f_addErrorMessage: function(clazz, errorMessage) {
		var summary=null;
		var detail=null;
		var severity=f_messageObject.SEVERITY_ERROR;
		
		var validatorParams=this._validatorParams;
		if (validatorParams) {
			summary=validatorParams[errorMessage+".summary"];
			if (summary) {
				detail=validatorParams[errorMessage+".detail"];
			} else {
				summary=validatorParams[errorMessage];
			}			
		}
		
		if (!summary) {
			var resourceBundle=f_resourceBundle.Get(clazz);
			
			summary=resourceBundle.f_get(errorMessage.toUpperCase().replace(/\./g, "_")+"_SUMMARY");
		}

		var message=new f_messageObject(severity, summary, detail);
		
		var messageContext=f_messageContext.Get(this);
		messageContext.f_addMessageObject(this, message);
	},
	
	f_update: function() {
		this.f_performMessageChanges();	
				
		return this.f_super(arguments);	
	}
}
 
new f_class("f_compositeNumEntry", null, null, __prototype, f_component, fa_compositeNumEntry, fa_required, fa_message);
